<bugID>1059591<Summary>Incorrectly formatted remotely hosted links causes new tab to be empty</Summary><Description>My new tab is showing all tiles with empty tiles.

$ curl -L -d '{"locale":"en-US"}' https://tiles.up.mozillalabs.com/v2/links/fetch
{"en-US": {"en-US": [{"directoryId": 1, ..

There's an extra layer of { "en-US", so when the client accesses "en-US" and expects an array but gets an object, .map fails:

http://mxr.mozilla.org/mozilla-central/source/toolkit/modules/DirectoryLinksProvider.jsm#382
382       aCallback(rawLinks.map((link, position) =&gt; {

rawLinks.map fails and the callback is never called, so newtab page is borked.</Description></bugID>